﻿"""__init__.py"""

import sys
from typing import TYPE_CHECKING

from lazy_imports import LazyImporter


if TYPE_CHECKING:
    from ._1172 import ConceptGearDesign
    from ._1173 import ConceptGearMeshDesign
    from ._1174 import ConceptGearSetDesign
else:
    import_structure = {
        '_1172': ['ConceptGearDesign'],
        '_1173': ['ConceptGearMeshDesign'],
        '_1174': ['ConceptGearSetDesign'],
    }

    sys.modules[__name__] = LazyImporter(
        __name__,
        globals()['__file__'],
        import_structure,
    )
