﻿"""_684.py

ProcessSimulationViewModel
"""
from __future__ import annotations

from typing import TYPE_CHECKING, TypeVar, Generic

from mastapy.gears.manufacturing.cylindrical import _625
from mastapy._internal.cast_exception import CastException
from mastapy._internal.python_net import python_net_import

_PROCESS_SIMULATION_VIEW_MODEL = python_net_import('SMT.MastaAPI.Gears.Manufacturing.Cylindrical.HobbingProcessSimulationNew', 'ProcessSimulationViewModel')


__docformat__ = 'restructuredtext en'
__all__ = ('ProcessSimulationViewModel',)


T = TypeVar('T')


class ProcessSimulationViewModel(_625.GearManufacturingConfigurationViewModel, Generic[T]):
    """ProcessSimulationViewModel

    This is a mastapy class.

    Generic Types:
        T
    """

    TYPE = _PROCESS_SIMULATION_VIEW_MODEL

    class _Cast_ProcessSimulationViewModel:
        """Special nested class for casting ProcessSimulationViewModel to subclasses."""

        def __init__(self, parent: 'ProcessSimulationViewModel'):
            self._parent = parent

        @property
        def gear_manufacturing_configuration_view_model(self):
            return self._parent._cast(_625.GearManufacturingConfigurationViewModel)

        @property
        def hobbing_process_simulation_view_model(self):
            from mastapy.gears.manufacturing.cylindrical.hobbing_process_simulation_new import _671
            
            return self._parent._cast(_671.HobbingProcessSimulationViewModel)

        @property
        def worm_grinding_process_simulation_view_model(self):
            from mastapy.gears.manufacturing.cylindrical.hobbing_process_simulation_new import _698
            
            return self._parent._cast(_698.WormGrindingProcessSimulationViewModel)

        @property
        def process_simulation_view_model(self) -> 'ProcessSimulationViewModel':
            return self._parent

        def __getattr__(self, name: str):
            try:
                return self.__dict__[name]
            except KeyError:
                class_name = ''.join(n.capitalize() for n in name.split('_'))
                raise CastException(f'Detected an invalid cast. Cannot cast to type "{class_name}"') from None

    def __init__(self, instance_to_wrap: 'ProcessSimulationViewModel.TYPE'):
        super().__init__(instance_to_wrap)
        self._freeze()

    @property
    def cast_to(self) -> 'ProcessSimulationViewModel._Cast_ProcessSimulationViewModel':
        return self._Cast_ProcessSimulationViewModel(self)
