﻿"""__init__.py"""

import sys
from typing import TYPE_CHECKING

from lazy_imports import LazyImporter


if TYPE_CHECKING:
    from ._6246 import AbstractAssemblyDynamicAnalysis
    from ._6247 import AbstractShaftDynamicAnalysis
    from ._6248 import AbstractShaftOrHousingDynamicAnalysis
    from ._6249 import AbstractShaftToMountableComponentConnectionDynamicAnalysis
    from ._6250 import AGMAGleasonConicalGearDynamicAnalysis
    from ._6251 import AGMAGleasonConicalGearMeshDynamicAnalysis
    from ._6252 import AGMAGleasonConicalGearSetDynamicAnalysis
    from ._6253 import AssemblyDynamicAnalysis
    from ._6254 import BearingDynamicAnalysis
    from ._6255 import BeltConnectionDynamicAnalysis
    from ._6256 import BeltDriveDynamicAnalysis
    from ._6257 import BevelDifferentialGearDynamicAnalysis
    from ._6258 import BevelDifferentialGearMeshDynamicAnalysis
    from ._6259 import BevelDifferentialGearSetDynamicAnalysis
    from ._6260 import BevelDifferentialPlanetGearDynamicAnalysis
    from ._6261 import BevelDifferentialSunGearDynamicAnalysis
    from ._6262 import BevelGearDynamicAnalysis
    from ._6263 import BevelGearMeshDynamicAnalysis
    from ._6264 import BevelGearSetDynamicAnalysis
    from ._6265 import BoltDynamicAnalysis
    from ._6266 import BoltedJointDynamicAnalysis
    from ._6267 import ClutchConnectionDynamicAnalysis
    from ._6268 import ClutchDynamicAnalysis
    from ._6269 import ClutchHalfDynamicAnalysis
    from ._6270 import CoaxialConnectionDynamicAnalysis
    from ._6271 import ComponentDynamicAnalysis
    from ._6272 import ConceptCouplingConnectionDynamicAnalysis
    from ._6273 import ConceptCouplingDynamicAnalysis
    from ._6274 import ConceptCouplingHalfDynamicAnalysis
    from ._6275 import ConceptGearDynamicAnalysis
    from ._6276 import ConceptGearMeshDynamicAnalysis
    from ._6277 import ConceptGearSetDynamicAnalysis
    from ._6278 import ConicalGearDynamicAnalysis
    from ._6279 import ConicalGearMeshDynamicAnalysis
    from ._6280 import ConicalGearSetDynamicAnalysis
    from ._6281 import ConnectionDynamicAnalysis
    from ._6282 import ConnectorDynamicAnalysis
    from ._6283 import CouplingConnectionDynamicAnalysis
    from ._6284 import CouplingDynamicAnalysis
    from ._6285 import CouplingHalfDynamicAnalysis
    from ._6286 import CVTBeltConnectionDynamicAnalysis
    from ._6287 import CVTDynamicAnalysis
    from ._6288 import CVTPulleyDynamicAnalysis
    from ._6289 import CycloidalAssemblyDynamicAnalysis
    from ._6290 import CycloidalDiscCentralBearingConnectionDynamicAnalysis
    from ._6291 import CycloidalDiscDynamicAnalysis
    from ._6292 import CycloidalDiscPlanetaryBearingConnectionDynamicAnalysis
    from ._6293 import CylindricalGearDynamicAnalysis
    from ._6294 import CylindricalGearMeshDynamicAnalysis
    from ._6295 import CylindricalGearSetDynamicAnalysis
    from ._6296 import CylindricalPlanetGearDynamicAnalysis
    from ._6297 import DatumDynamicAnalysis
    from ._2608 import DynamicAnalysis
    from ._6298 import DynamicAnalysisDrawStyle
    from ._6299 import ExternalCADModelDynamicAnalysis
    from ._6300 import FaceGearDynamicAnalysis
    from ._6301 import FaceGearMeshDynamicAnalysis
    from ._6302 import FaceGearSetDynamicAnalysis
    from ._6303 import FEPartDynamicAnalysis
    from ._6304 import FlexiblePinAssemblyDynamicAnalysis
    from ._6305 import GearDynamicAnalysis
    from ._6306 import GearMeshDynamicAnalysis
    from ._6307 import GearSetDynamicAnalysis
    from ._6308 import GuideDxfModelDynamicAnalysis
    from ._6309 import HypoidGearDynamicAnalysis
    from ._6310 import HypoidGearMeshDynamicAnalysis
    from ._6311 import HypoidGearSetDynamicAnalysis
    from ._6312 import InterMountableComponentConnectionDynamicAnalysis
    from ._6313 import KlingelnbergCycloPalloidConicalGearDynamicAnalysis
    from ._6314 import KlingelnbergCycloPalloidConicalGearMeshDynamicAnalysis
    from ._6315 import KlingelnbergCycloPalloidConicalGearSetDynamicAnalysis
    from ._6316 import KlingelnbergCycloPalloidHypoidGearDynamicAnalysis
    from ._6317 import KlingelnbergCycloPalloidHypoidGearMeshDynamicAnalysis
    from ._6318 import KlingelnbergCycloPalloidHypoidGearSetDynamicAnalysis
    from ._6319 import KlingelnbergCycloPalloidSpiralBevelGearDynamicAnalysis
    from ._6320 import KlingelnbergCycloPalloidSpiralBevelGearMeshDynamicAnalysis
    from ._6321 import KlingelnbergCycloPalloidSpiralBevelGearSetDynamicAnalysis
    from ._6322 import MassDiscDynamicAnalysis
    from ._6323 import MeasurementComponentDynamicAnalysis
    from ._6324 import MountableComponentDynamicAnalysis
    from ._6325 import OilSealDynamicAnalysis
    from ._6326 import PartDynamicAnalysis
    from ._6327 import PartToPartShearCouplingConnectionDynamicAnalysis
    from ._6328 import PartToPartShearCouplingDynamicAnalysis
    from ._6329 import PartToPartShearCouplingHalfDynamicAnalysis
    from ._6330 import PlanetaryConnectionDynamicAnalysis
    from ._6331 import PlanetaryGearSetDynamicAnalysis
    from ._6332 import PlanetCarrierDynamicAnalysis
    from ._6333 import PointLoadDynamicAnalysis
    from ._6334 import PowerLoadDynamicAnalysis
    from ._6335 import PulleyDynamicAnalysis
    from ._6336 import RingPinsDynamicAnalysis
    from ._6337 import RingPinsToDiscConnectionDynamicAnalysis
    from ._6338 import RollingRingAssemblyDynamicAnalysis
    from ._6339 import RollingRingConnectionDynamicAnalysis
    from ._6340 import RollingRingDynamicAnalysis
    from ._6341 import RootAssemblyDynamicAnalysis
    from ._6342 import ShaftDynamicAnalysis
    from ._6343 import ShaftHubConnectionDynamicAnalysis
    from ._6344 import ShaftToMountableComponentConnectionDynamicAnalysis
    from ._6345 import SpecialisedAssemblyDynamicAnalysis
    from ._6346 import SpiralBevelGearDynamicAnalysis
    from ._6347 import SpiralBevelGearMeshDynamicAnalysis
    from ._6348 import SpiralBevelGearSetDynamicAnalysis
    from ._6349 import SpringDamperConnectionDynamicAnalysis
    from ._6350 import SpringDamperDynamicAnalysis
    from ._6351 import SpringDamperHalfDynamicAnalysis
    from ._6352 import StraightBevelDiffGearDynamicAnalysis
    from ._6353 import StraightBevelDiffGearMeshDynamicAnalysis
    from ._6354 import StraightBevelDiffGearSetDynamicAnalysis
    from ._6355 import StraightBevelGearDynamicAnalysis
    from ._6356 import StraightBevelGearMeshDynamicAnalysis
    from ._6357 import StraightBevelGearSetDynamicAnalysis
    from ._6358 import StraightBevelPlanetGearDynamicAnalysis
    from ._6359 import StraightBevelSunGearDynamicAnalysis
    from ._6360 import SynchroniserDynamicAnalysis
    from ._6361 import SynchroniserHalfDynamicAnalysis
    from ._6362 import SynchroniserPartDynamicAnalysis
    from ._6363 import SynchroniserSleeveDynamicAnalysis
    from ._6364 import TorqueConverterConnectionDynamicAnalysis
    from ._6365 import TorqueConverterDynamicAnalysis
    from ._6366 import TorqueConverterPumpDynamicAnalysis
    from ._6367 import TorqueConverterTurbineDynamicAnalysis
    from ._6368 import UnbalancedMassDynamicAnalysis
    from ._6369 import VirtualComponentDynamicAnalysis
    from ._6370 import WormGearDynamicAnalysis
    from ._6371 import WormGearMeshDynamicAnalysis
    from ._6372 import WormGearSetDynamicAnalysis
    from ._6373 import ZerolBevelGearDynamicAnalysis
    from ._6374 import ZerolBevelGearMeshDynamicAnalysis
    from ._6375 import ZerolBevelGearSetDynamicAnalysis
else:
    import_structure = {
        '_6246': ['AbstractAssemblyDynamicAnalysis'],
        '_6247': ['AbstractShaftDynamicAnalysis'],
        '_6248': ['AbstractShaftOrHousingDynamicAnalysis'],
        '_6249': ['AbstractShaftToMountableComponentConnectionDynamicAnalysis'],
        '_6250': ['AGMAGleasonConicalGearDynamicAnalysis'],
        '_6251': ['AGMAGleasonConicalGearMeshDynamicAnalysis'],
        '_6252': ['AGMAGleasonConicalGearSetDynamicAnalysis'],
        '_6253': ['AssemblyDynamicAnalysis'],
        '_6254': ['BearingDynamicAnalysis'],
        '_6255': ['BeltConnectionDynamicAnalysis'],
        '_6256': ['BeltDriveDynamicAnalysis'],
        '_6257': ['BevelDifferentialGearDynamicAnalysis'],
        '_6258': ['BevelDifferentialGearMeshDynamicAnalysis'],
        '_6259': ['BevelDifferentialGearSetDynamicAnalysis'],
        '_6260': ['BevelDifferentialPlanetGearDynamicAnalysis'],
        '_6261': ['BevelDifferentialSunGearDynamicAnalysis'],
        '_6262': ['BevelGearDynamicAnalysis'],
        '_6263': ['BevelGearMeshDynamicAnalysis'],
        '_6264': ['BevelGearSetDynamicAnalysis'],
        '_6265': ['BoltDynamicAnalysis'],
        '_6266': ['BoltedJointDynamicAnalysis'],
        '_6267': ['ClutchConnectionDynamicAnalysis'],
        '_6268': ['ClutchDynamicAnalysis'],
        '_6269': ['ClutchHalfDynamicAnalysis'],
        '_6270': ['CoaxialConnectionDynamicAnalysis'],
        '_6271': ['ComponentDynamicAnalysis'],
        '_6272': ['ConceptCouplingConnectionDynamicAnalysis'],
        '_6273': ['ConceptCouplingDynamicAnalysis'],
        '_6274': ['ConceptCouplingHalfDynamicAnalysis'],
        '_6275': ['ConceptGearDynamicAnalysis'],
        '_6276': ['ConceptGearMeshDynamicAnalysis'],
        '_6277': ['ConceptGearSetDynamicAnalysis'],
        '_6278': ['ConicalGearDynamicAnalysis'],
        '_6279': ['ConicalGearMeshDynamicAnalysis'],
        '_6280': ['ConicalGearSetDynamicAnalysis'],
        '_6281': ['ConnectionDynamicAnalysis'],
        '_6282': ['ConnectorDynamicAnalysis'],
        '_6283': ['CouplingConnectionDynamicAnalysis'],
        '_6284': ['CouplingDynamicAnalysis'],
        '_6285': ['CouplingHalfDynamicAnalysis'],
        '_6286': ['CVTBeltConnectionDynamicAnalysis'],
        '_6287': ['CVTDynamicAnalysis'],
        '_6288': ['CVTPulleyDynamicAnalysis'],
        '_6289': ['CycloidalAssemblyDynamicAnalysis'],
        '_6290': ['CycloidalDiscCentralBearingConnectionDynamicAnalysis'],
        '_6291': ['CycloidalDiscDynamicAnalysis'],
        '_6292': ['CycloidalDiscPlanetaryBearingConnectionDynamicAnalysis'],
        '_6293': ['CylindricalGearDynamicAnalysis'],
        '_6294': ['CylindricalGearMeshDynamicAnalysis'],
        '_6295': ['CylindricalGearSetDynamicAnalysis'],
        '_6296': ['CylindricalPlanetGearDynamicAnalysis'],
        '_6297': ['DatumDynamicAnalysis'],
        '_2608': ['DynamicAnalysis'],
        '_6298': ['DynamicAnalysisDrawStyle'],
        '_6299': ['ExternalCADModelDynamicAnalysis'],
        '_6300': ['FaceGearDynamicAnalysis'],
        '_6301': ['FaceGearMeshDynamicAnalysis'],
        '_6302': ['FaceGearSetDynamicAnalysis'],
        '_6303': ['FEPartDynamicAnalysis'],
        '_6304': ['FlexiblePinAssemblyDynamicAnalysis'],
        '_6305': ['GearDynamicAnalysis'],
        '_6306': ['GearMeshDynamicAnalysis'],
        '_6307': ['GearSetDynamicAnalysis'],
        '_6308': ['GuideDxfModelDynamicAnalysis'],
        '_6309': ['HypoidGearDynamicAnalysis'],
        '_6310': ['HypoidGearMeshDynamicAnalysis'],
        '_6311': ['HypoidGearSetDynamicAnalysis'],
        '_6312': ['InterMountableComponentConnectionDynamicAnalysis'],
        '_6313': ['KlingelnbergCycloPalloidConicalGearDynamicAnalysis'],
        '_6314': ['KlingelnbergCycloPalloidConicalGearMeshDynamicAnalysis'],
        '_6315': ['KlingelnbergCycloPalloidConicalGearSetDynamicAnalysis'],
        '_6316': ['KlingelnbergCycloPalloidHypoidGearDynamicAnalysis'],
        '_6317': ['KlingelnbergCycloPalloidHypoidGearMeshDynamicAnalysis'],
        '_6318': ['KlingelnbergCycloPalloidHypoidGearSetDynamicAnalysis'],
        '_6319': ['KlingelnbergCycloPalloidSpiralBevelGearDynamicAnalysis'],
        '_6320': ['KlingelnbergCycloPalloidSpiralBevelGearMeshDynamicAnalysis'],
        '_6321': ['KlingelnbergCycloPalloidSpiralBevelGearSetDynamicAnalysis'],
        '_6322': ['MassDiscDynamicAnalysis'],
        '_6323': ['MeasurementComponentDynamicAnalysis'],
        '_6324': ['MountableComponentDynamicAnalysis'],
        '_6325': ['OilSealDynamicAnalysis'],
        '_6326': ['PartDynamicAnalysis'],
        '_6327': ['PartToPartShearCouplingConnectionDynamicAnalysis'],
        '_6328': ['PartToPartShearCouplingDynamicAnalysis'],
        '_6329': ['PartToPartShearCouplingHalfDynamicAnalysis'],
        '_6330': ['PlanetaryConnectionDynamicAnalysis'],
        '_6331': ['PlanetaryGearSetDynamicAnalysis'],
        '_6332': ['PlanetCarrierDynamicAnalysis'],
        '_6333': ['PointLoadDynamicAnalysis'],
        '_6334': ['PowerLoadDynamicAnalysis'],
        '_6335': ['PulleyDynamicAnalysis'],
        '_6336': ['RingPinsDynamicAnalysis'],
        '_6337': ['RingPinsToDiscConnectionDynamicAnalysis'],
        '_6338': ['RollingRingAssemblyDynamicAnalysis'],
        '_6339': ['RollingRingConnectionDynamicAnalysis'],
        '_6340': ['RollingRingDynamicAnalysis'],
        '_6341': ['RootAssemblyDynamicAnalysis'],
        '_6342': ['ShaftDynamicAnalysis'],
        '_6343': ['ShaftHubConnectionDynamicAnalysis'],
        '_6344': ['ShaftToMountableComponentConnectionDynamicAnalysis'],
        '_6345': ['SpecialisedAssemblyDynamicAnalysis'],
        '_6346': ['SpiralBevelGearDynamicAnalysis'],
        '_6347': ['SpiralBevelGearMeshDynamicAnalysis'],
        '_6348': ['SpiralBevelGearSetDynamicAnalysis'],
        '_6349': ['SpringDamperConnectionDynamicAnalysis'],
        '_6350': ['SpringDamperDynamicAnalysis'],
        '_6351': ['SpringDamperHalfDynamicAnalysis'],
        '_6352': ['StraightBevelDiffGearDynamicAnalysis'],
        '_6353': ['StraightBevelDiffGearMeshDynamicAnalysis'],
        '_6354': ['StraightBevelDiffGearSetDynamicAnalysis'],
        '_6355': ['StraightBevelGearDynamicAnalysis'],
        '_6356': ['StraightBevelGearMeshDynamicAnalysis'],
        '_6357': ['StraightBevelGearSetDynamicAnalysis'],
        '_6358': ['StraightBevelPlanetGearDynamicAnalysis'],
        '_6359': ['StraightBevelSunGearDynamicAnalysis'],
        '_6360': ['SynchroniserDynamicAnalysis'],
        '_6361': ['SynchroniserHalfDynamicAnalysis'],
        '_6362': ['SynchroniserPartDynamicAnalysis'],
        '_6363': ['SynchroniserSleeveDynamicAnalysis'],
        '_6364': ['TorqueConverterConnectionDynamicAnalysis'],
        '_6365': ['TorqueConverterDynamicAnalysis'],
        '_6366': ['TorqueConverterPumpDynamicAnalysis'],
        '_6367': ['TorqueConverterTurbineDynamicAnalysis'],
        '_6368': ['UnbalancedMassDynamicAnalysis'],
        '_6369': ['VirtualComponentDynamicAnalysis'],
        '_6370': ['WormGearDynamicAnalysis'],
        '_6371': ['WormGearMeshDynamicAnalysis'],
        '_6372': ['WormGearSetDynamicAnalysis'],
        '_6373': ['ZerolBevelGearDynamicAnalysis'],
        '_6374': ['ZerolBevelGearMeshDynamicAnalysis'],
        '_6375': ['ZerolBevelGearSetDynamicAnalysis'],
    }

    sys.modules[__name__] = LazyImporter(
        __name__,
        globals()['__file__'],
        import_structure,
    )
